/*
 *   AT24C32/64
 *
 *  Created: 04.09.2014 10:15:34 
 *  Author:   
 */ 
#include <avr/interrupt.h>
#define   RX_AT24 1  //
#define   TX_AT24 0  //
#define   Int_ 5
#define   Char_ 0 
	
volatile uint8_t I2C_Bit = 0,I2C_Status,I2C_Kol_Masiv,I2C_AdresYctroistva,AT24C_Sostoania,I2C_Kol,Vibor_I2C; 
volatile uint16_t *I2C_Masiv,I2C_Adrec,TekY_Adres_AT24C;

ISR (TWI_vect)
  { 	  
      AT24C_TX_RX_();
  } 
  //**********************//   
  //**********************// 
 
 //**********************//   
 //**********************// 
void AT24C_TX_RX_()   //    I2C   
 { 
   volatile static uint8_t I2C_Temp1;      
   I2C_Temp1 = TWSR & 0b1111000;     
   if ( I2C_Status == I2C_Temp1 )	 //     	 
	{		 	  	  
	  switch (I2C_Bit)
       {
	     case 0: 	  //          
				 I2C_Bit = 1;  					   				 													  					    
				 I2C_Status = 0x18;                       //  "   (SLA + N)    (ACK)" 	
			     TWDR = I2C_AdresYctroistva &(~(1<<0));   //   (  )   							    		    				  				  	                   			   		         		 		        					 
		         TWCR = 0b11001101; 				   				 	
				 break;	
		 case 8: 	  //    
		       	 I2C_Bit = 5; 	        
				 I2C_Status = 0x10;                   // "
				 TWDR = I2C_AdresYctroistva |(1<<0);  //   (  )	
				 TWCR = 0b11101101;						 					 				 					 				 					  
				 break;		   	 				 				 
			 //********************//
			    //       
			 //********************//         				  				 				
		 case 1: 
		         I2C_Status = 0x28;      //  "     "				 
				 I2C_Bit = 2; 
				 TekY_Adres_AT24C = I2C_Adrec;
				 TWDR = I2C_Adrec >> 8;  //  	 
				 TWCR = 0b11001101;					 		 
				 break;     
		 case 2:		 				 
				 I2C_Bit = 3;
				 TWDR = I2C_Adrec & 0xFF ;  //  
				 if (Vibor_I2C & (1<<0))    //  			
				   I2C_Bit = 8;   	  		   
				 TWCR = 0b11001101;				 				 
				 break;     
			 //===================//
			    //    1  2 
			 //===================//  	 
		 case 3: 
		         if ( Vibor_I2C & (1<<5))    
		          {					  
					if ( Vibor_I2C & (1<<6))
					 { 
                       TWDR =((I2C_Masiv[I2C_Kol]) & 0xFF); //
					   I2C_Kol ++;
					   TekY_Adres_AT24C = TekY_Adres_AT24C + 2;
					   Vibor_I2C &=~(1<<6); 
					 } 
					else
					 {
					   TWDR = (I2C_Masiv[I2C_Kol]  >> 8); //
					   Vibor_I2C |=(1<<6);   
					 }					 					  					
		          }
		         else  
				  {
					TWDR = I2C_Masiv[I2C_Kol];     //    char				   	
				    I2C_Kol ++;
					TekY_Adres_AT24C++; 				       				     					 					  
				  }	
				 if ( I2C_Kol == I2C_Kol_Masiv )   //    				  
				   I2C_Bit = 4; 
				 TWCR = 0b11001101; 	          		        						   					 				 					   					 				 				 					  				  		         
				 break;
			//====================//
			      // 
			//====================//	 			 			  	     					   				  				   				 				 		         
		 case 4: 
                 TWCR = 0b11011101;  // 	
				 I2C_Bit = 0;
				 I2C_Kol = 0;				 
				 AT24C_Sostoania = 0;				 
		 	 	 break;	
			//**********************//	    		 				 								 					         				  				 				
		 case 5: 		         
		         TWCR = 0b11001101;	
				 I2C_Status = 0x40; 				 
				 I2C_Bit = 7;
				 break;
		//************************************//		 
			//  1  2 
		//************************************//		 
		 case 6: 
		         if ( Vibor_I2C & (1<<5))    
		          {
					I2C_Bit = TWDR;  
					if ( Vibor_I2C & (1<<6))
					 { 
                       I2C_Masiv[I2C_Kol] = I2C_Adrec | I2C_Bit; 
					   I2C_Kol ++;
					   TekY_Adres_AT24C = TekY_Adres_AT24C + 2;
					   Vibor_I2C &=~(1<<6); 
					 } 
					else
					 {
					   I2C_Adrec = I2C_Bit << 8;//
					   Vibor_I2C |=(1<<6);   
					 }					 					  					
		          }
		         else  
		          {
					I2C_Masiv[I2C_Kol] = TWDR;
					TekY_Adres_AT24C ++;  									   					 				 
				    I2C_Kol ++;  
				  }		       	         				 
		 case 7: 
		         I2C_Status = 0x50;                 //  "     "	
		         I2C_Bit = 6;		 				 					  				  		           	   
		         if ( I2C_Kol < I2C_Kol_Masiv )
		          TWCR = 0b11001101;                   
				  else
				   {
					 TWCR = 0b10001101;
					 I2C_Status = 0x58; 
					 I2C_Bit = 4; 
				   }				   				 					  				  	 					   
		 	 	 break;	 	 
	   }		    	     	     	  	 
    }
	else
    {
	   TWCR = 0b10000000;
	   AT24C_Sostoania = I2C_Temp1; //  	       	 		 		 		 
	}  
 }
 //********************************//
 //********************************//
 void AT24C( uint8_t A,uint8_t B,uint8_t D,uint16_t E,uint16_t Y,uint16_t *S )
   {
	 asm("cli");	
	 I2C_Masiv = S;
	 I2C_AdresYctroistva =A;
	 Vibor_I2C = B;
	 if ( Y == 5 )	 
	   Vibor_I2C |= (1<<5); 
	  else
	   Vibor_I2C &=~ (1<<5); 
	 I2C_Adrec = D;
	 I2C_Kol_Masiv = E;
	 I2C_Status = 0x08;
	 AT24C_Sostoania |= (1<<0); 
	 TWCR |= (1<<TWIE);TWCR |= (1<<TWEA)|(1<<TWSTA)|(1<<TWEN);//  ""
	 asm("Sei");        
  
   }
